//+------------------------------------------------------------------+
//|                                                                  |
//|                                                     kishartr     |
//|                                                                  |
//+------------------------------------------------------------------+
#property link      ""

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

extern double MR = 0.6;
extern int p = 14;
extern int levup = 40;
extern int levdn = 60;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int cnt, total;
double rsi_3, rsi_2, rsi_1, rsi, rsi2, lots;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {//1
  
  total = OrdersTotal();
  if(total > 0)
    ClosePosition();   
  if(total < 1)
    OpenPosition();
     
   }//1
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   
void OpenPosition()
  {//1 
  lots = Lots();
  if(Signal() > 0)
    {//2
    OrderSend(Symbol(),OP_BUY,lots,Ask,10,0,0,"Buy",0,0,Blue); 
    return(0);
    }//2
  if(Signal() < 0)
    {//2
    OrderSend(Symbol(),OP_SELL,lots,Bid,10,0,0,"Sell",0,0,Red);
    return(0);
    }//2
   
   return(0);
  }//1
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void ClosePosition()
  {//1
  for(cnt=0;cnt<total;cnt++)
    {//2
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if(OrderType() <= OP_SELL && 
       OrderSymbol() == Symbol())
        {//3
         if(OrderType() == OP_BUY)
           {//4
           if(Signal() < 0)
             {//5
             OrderClose(OrderTicket(),OrderLots(),Bid,0,Red);
             return(0);
             }//5
           }//4
         if(OrderType() == OP_SELL)
           {//4
           if(Signal() > 0)
             {//5   
             OrderClose(OrderTicket(),OrderLots(),Ask,0,Blue);
             return(0);
             }//5
           }//4
         }//3
       }//2
     return(0);
   }//1
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int Signal()
  {//1
  rsi = iRSI(NULL,0,p,0,1);
  rsi2= iRSI(NULL,0,p,0,2);
    {//2
    if((rsi2 < levup) && (rsi > levup))
      {//3
      return(1);
      }//3
    if((rsi2 > levdn) && (rsi < levdn))
      {//3
      return(-1);
      }//3
    }//2
  return(0);
  }//1
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*
double UP()
  {//1
  int k;
  for(k=0;;k++)
    {//2
    rsi_3 = iRSI(NULL,0,p,0,k+3);
    rsi_2 = iRSI(NULL,0,p,0,k+2);
    rsi_1 = iRSI(NULL,0,p,0,k+1);
    if((rsi_3 < rsi_2) && (rsi_2 > rsi_1))
      {//3
      return(rsi_2);
      }//3
    }//2
  }//1
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

double DN()
  {//1
  int l;
  for(l=0;;l++)
    {//2
    rsi_3 = iRSI(NULL,0,p,0,l+3);
    rsi_2 = iRSI(NULL,0,p,0,l+2);
    rsi_1 = iRSI(NULL,0,p,0,l+1);
    if((rsi_3 > rsi_2) && (rsi_2 < rsi_1))
      {//3
      return(rsi_2);
      }//3
    }//2
  }//1
*/
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
  
double Lots()
  {//1
  double m = MarketInfo(Symbol(),MODE_MARGINREQUIRED);
  double n = MarketInfo(Symbol(),MODE_MINLOT);
  double x = MarketInfo(Symbol(),MODE_MAXLOT);
  double lot = NormalizeDouble(AccountFreeMargin()*MR/m,1);
  if(lot<n) lot=n;
  if(lot>x) lot=x;
  return(lot);
  }//1